/*
 * Java-Gnome Bindings Library
 *
 * Copyright 1998-2005 the Java-Gnome Team, all rights reserved.
 *
 * The Java-Gnome bindings library is free software distributed under
 * the terms of the GNU Library General Public License version 2.
 */

package org.gnu.gtk;

/**
 * Exception thrown when a user calls a method on a GtkObject that has already
 * been destroyed.
 * 
 * @author Ismael Juma <ismael@juma.me.uk>
 *
 * @deprecated This class is part of the java-gnome 2.x family of libraries,
 *             which, due to their inefficiency and complexity, are no longer
 *             being maintained and have been abandoned by the java-gnome
 *             project. This class may in the future have an equivalent in
 *             java-gnome 4.0, try looking for
 *             <code>org.gnome.gtk.ObjectDestroyedException</code>.
 *             You should be aware that there is a considerably different API
 *             in the new library: the architecture is completely different
 *             and most notably internals are no longer exposed to public view.
 */
public class ObjectDestroyedException extends RuntimeException {

    public ObjectDestroyedException() {
        super();
    }

    public ObjectDestroyedException(String msg) {
        super(msg);
    }
}
